// File: "jss-ajax.js"

// Author: Marc Feeley
//   Dec 4, 2007 : version 1.0

// AJAX functions

function jss_XMLHttpRequest (req)
{ this.req = req
  jss_wq_init (this)
}

function jss_make_XMLHttpRequest (req)
{ return new jss_XMLHttpRequest (req)
}

function scm_XMLHttpRequest (k,url,timeout)
{ var req

  if (window.XMLHttpRequest)
    { // Mozilla, Safari, ...
      req = new XMLHttpRequest ()
      if (req.overrideMimeType)
        { req.overrideMimeType ("text/plain")
        }
    }
  else if (window.ActiveXObject)
    { // IE
      try
        { req = new ActiveXObject ("Msxml2.XMLHTTP")
        }
      catch (e)
        { try
            { req = new ActiveXObject ("Microsoft.XMLHTTP")
            }
          catch (e)
            {
            }
        }
    }

  if (req)
    { var xmlreq = jss_make_XMLHttpRequest (req)

      if (timeout === undefined)
        { var ct = jss_current_thread ()
          jss_thread_cont_set (ct, k)
          jss_thread_nextpc_set (ct, false)
          jss_wq_deq (ct)
          jss_wq_enq (xmlreq, ct)
        }
      else
        { var wakeup = jss_timeout_to_wakeup (timeout)
          if (wakeup <= jss_current_msecs ())
            return function () { return k (false) }
          else
            { var ct = jss_current_thread ()
              jss_thread_cont_set (ct, jss_XMLHttpRequest_aborter (xmlreq, k))
              jss_thread_nextpc_set (ct, false)
              jss_thread_wakeup_set (ct, wakeup)
              jss_wq_deq (ct)
              jss_wq_enq (xmlreq, ct)
              jss_sleepq_add (ct)
            }
        }

      req.onreadystatechange =
        function () { jss_XMLHttpRequest_handler (xmlreq) }
      req.open ("GET", url, true)
      req.setRequestHeader ("Content-Type", "text/plain")
      req.send (null)

      return jss_schedule_next ()
    }
}

function jss_XMLHttpRequest_aborter (xmlreq,k)
{ return function (result)
         { if (xmlreq.req.readyState != 4)
             xmlreq.req.abort ()
           return function () { return k (result) }
         }
}

function jss_XMLHttpRequest_handler (xmlreq)
{ if (xmlreq.req.readyState == 4)
    { var t = xmlreq.jss_wq_next
      if (t !== xmlreq)
        { var result
          if (xmlreq.req.status == 200)
            result = xmlreq.req.responseText
          else
            result = false
          jss_thread_continue (t, result)
          jss_run ()
        }
    }
}
